// C Source File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AGENDA V4.2  oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------


#include "IncludeAll.h"

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

void stIdle ()
{
	ST_busy (ACTIVITY_IDLE);
}

// --------------------------------------------------------------------------

void stBusy ()
{
	ST_busy (ACTIVITY_BUSY);
}

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

void InitScreen ()
{
	SCR_RECT	ClientArea	= {{4,4,235,116}};
	SCR_RECT	StatusArea	= {{0,121,239,127}};
	SCR_RECT	HeadBox 	= {{4, 4, 235, 12}};
	DrawBorder (0,0,239,120);
	ScrRectFill (&ClientArea, ScrRect, A_REVERSE);
	ScrRectFill (&StatusArea, ScrRect, A_REVERSE);
	ScrRectFill (&HeadBox, ScrRect, A_NORMAL);
	DrawLine (4,14,236,14, A_NORMAL);
	if (gr_Agenda->UseClock)
	{
		DrawLine (183, 3, 183, 12, A_REVERSE);	
		CBShowClock ();
	}	
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

void EmptyScreenClient ()
{
	SCR_RECT	ClientArea	= {{4,15,235,116}};
	ScrRectFill (&ClientArea, ScrRect, A_REVERSE);
	PrintHeadBox ((char *)"");
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

void PrintHeadBox (char *data)
{
	// texts longer than 29 chars are truncated
	short		Font;
	char		buf[40];

	strfill (buf, data, 29, ' ');
	Font = FontSetSys (F_6x8);
	DrawStr (5, 4, buf, A_REVERSE);
	FontSetSys (Font);
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

void ShowNumChanged ()
{
	char	buf[60];
	
	if (gr_Agenda->DataFile.Header->Flags & FLAGS_AB)
	{
		FontSetSys (F_4x6);
		sprintf (buf, "  %s %d  ", TEXT_CHANGES, gr_Agenda->DataFile.Header->nStarts);
		DrawStr ((240 - DrawStrWidth (buf, F_4x6)) / 2, 108, buf, A_REPLACE);
	}
	else ScrRectFill (&(SCR_RECT){{20, 108, 220, 114}}, ScrRect, A_REVERSE);


}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int ExecuteTask ()
{
	int		Ret		= ER_SUCCESS;
	int		Task	= 0;
	
	while (gr_Agenda->TaskQueue.NextTask != 0)
	{
		Task = gr_Agenda->TaskQueue.NextTask;
		gr_Agenda->TaskQueue.NextTask = 0;
		
		switch (Task)
		{
			case TASK_AGENDA:
				Ret = AgendaView (Task);
				break;
				
			case TASK_ADDRESSBOOK:
			case TASK_NOTEPAD:
			case TASK_INET_LINKS:
				Ret = LVView (Task);
				break;
			
		}
		if (gr_Agenda->Exit == TASK_CHANGE) gr_Agenda->Exit = 0;

		ShowErrors (Ret);
	}
	
	if (!gr_Agenda->Exit) DrawTaskMenu ();
	Task = (Task & 7) - 1;
	if (Task > 3 || Task < 0) Task = 0;	
	return (Task);	// return only a main task, corresponding with the task cursor.
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

void DrawTaskMenu ()
{

	EmptyScreenClient ();
	BitmapPut (16, 18, &IconLogo, ScrRect, A_REPLACE);
	BitmapPut (32, 53, &AgendaIcon, ScrRect, A_REPLACE);
	BitmapPut (80, 53, &AddressBookIcon, ScrRect, A_REPLACE);
	BitmapPut (128, 53, &NotesIcon, ScrRect, A_REPLACE);
	BitmapPut (176, 53, &InetLinksIcon, ScrRect, A_REPLACE);
	
	FontSetSys (F_8x10);
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int TMOnMenuOpen (void *ptr1, void *ptr2, int *Tag1, int *Tag2)
{
	ScrRectFill ((SCR_RECT *)ptr1, ScrRect, A_XOR);
	ScrRectFill ((SCR_RECT *)ptr2, ScrRect, A_XOR);

	return 0;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int TMOnMenuClose (void *ptr1, void *ptr2, int Tag1, int Tag2, int DidWhat, int Feedback) 
{
	TMOnMenuOpen (ptr1, ptr2, NULL, NULL);
	
	return 0;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --- TaskMenu -------------------------------------------------------------
// --- Returns the task from which was exited (0 in case of TaskMenu) -------
// --------------------------------------------------------------------------

int TaskMenu ()
{
	int			Selection	= 0;
	SCR_RECT	Cursor;
	SCR_RECT	DelArea		= {{30,90,210,103}};
	int			NextOP		= 1;
	int			key			= 0;
	TIdleLoop	idl;
	
	Cursor.xy.y0 = 53;
	Cursor.xy.y1 = 85;

	if (gr_Agenda->DataFile.Header->LastTask != TASK_TASKMENU)
	{
		resetTaskQueueParams ();
		gr_Agenda->TaskQueue.NextTask = gr_Agenda->DataFile.Header->LastTask;
		Selection = ExecuteTask () ;
	}
	else DrawTaskMenu ();
		
	idl.BeforeMenuHook = &TMOnMenuOpen;
	idl.AfterMenuHook = &TMOnMenuClose;
	idl.Ptr1 = &DelArea;
	idl.Task = TASK_TASKMENU;
		
	while (!gr_Agenda->Exit)
	{
		ShowNumChanged();
		Cursor.xy.x0 = 32-2 + Selection*(32+16);
		Cursor.xy.x1 = 32+32+2 + Selection*(32+16);
		if (NextOP)
		{
			ScrRectFill (&DelArea, ScrRect, A_REPLACE);
			FontSetSys (F_8x10);
			DrawStr ((240-strlen (TASK_NAMES[Selection])*8)/2, 92, TASK_NAMES[Selection], A_REVERSE);
			ScrRectFill (&Cursor, ScrRect, A_XOR);
			NextOP = 0;
		}
		idl.Ptr2 = &Cursor;
		IdleLoop (&idl, 0, &key, NULL, NULL);
		if ( (key == KEY_LEFT) && (Selection != 0) ) NextOP = -1;
		if ( (key == KEY_RIGHT) && (Selection != 3) ) NextOP = +1;
		if ( (key == KEY_ESC)) gr_Agenda->Exit = idl.Task;
		if (NextOP != 0)
		{
			ScrRectFill (&Cursor, ScrRect, A_XOR);
			Selection += NextOP;
		}
		
		if (gr_Agenda->Exit == TASK_CHANGE)
		{
			gr_Agenda->Exit = 0;
			Selection = ExecuteTask ();
			NextOP = 1;
		}		

		if (key == KEY_ENTER)
		{
			resetTaskQueueParams ();
			gr_Agenda->TaskQueue.NextTask = Selection +1;
			Selection = ExecuteTask ();
			NextOP = 1;
		}
		
	}

	return gr_Agenda->Exit;
}

// --------------------------------------------------------------------------


// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
