// C Source File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AGENDA V4.2  oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------


#include "IncludeAll.h"

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int CreateNoteEdit (TEntryType *ET, WINDOW *Win, HANDLE hBuf[], int init, int *Action)
{
	int				Ret			= ER_SUCCESS;
	int				Focus		= 1;
	int				Finish		= 0;
	int				oldFocus;
	int				key;
	TEXT_EDIT		te;
	EVENT			ev;
	TIdleLoop		idl;
	
	idl.Task = ET->Task;
	lastEditorMode (ET->Task, 1);
	
	while (!*Action && !gr_Agenda->Exit && Ret == ER_SUCCESS && !Finish)
	{
		if ( (Focus == 1) && !TE_open (&te, Win, MakeWinRect (56, 4, 226, 13), hBuf[0], 0, 0, 0) ) Ret = ER_MALLOC;
		if ( (Focus == 2) && !TE_open (&te, Win, MakeWinRect (3, 19, 226, 100), hBuf[1], 0, 0, 1) ) Ret = ER_MALLOC;
		if (Ret == ER_SUCCESS)
		{
			TE_select (&te, 0, 0);
			if (!init) TE_focus (&te);
			oldFocus = Focus;
			while ( (Focus == oldFocus) && !*Action && !gr_Agenda->Exit && !init)
			{
				IdleLoop (&idl, ILF_NOMENU, &key, NULL, &ev);
				if ( (Focus == 2) && ( (key == KEY_DIAMOND + KEY_UP) || ( (key == KEY_UP) && (te.CursorOffset == 0) ))) Focus = 1;
				if ( (Focus == 1) && ((key == KEY_ENTER) || (key == KEY_DOWN) || (key == KEY_DIAMOND + KEY_DOWN)) ) Focus = 2;
				else if (key == KEY_ESC) *Action = OK;
				else if (key == KEY_2ND + KEY_ESC) *Action = CANCEL;
				else					
				{
					TE_handleEvent (&te, &ev);
				}
			}
			TE_unfocus (&te);
		}
		
		if (init)
		{
			Focus++;
			if (Focus > 2) Finish = 1;
		}
		
		if (*Action == OK)
		{
			if (AllBlank (ET, hBuf)) *Action = CANCEL;
			else if ( peek (HeapDeref (hBuf[0])) == 0)
			{
				if (MsgBox (MSG_TITLE_HINT, MSG_NOTES_TITLE, BT_OK, BT_CANCEL) == OK) *Action = CANCEL;
				else *Action = 0;
			}
		}
	}
	
	if (gr_Agenda->Exit)
	{
		*Action = OK;
		if ( peek (HeapDeref (hBuf[0])) == 0) *Action = CANCEL;
	}
	// --- if !Agenda.Exit then save last mode that not in editor
	else lastEditorMode (ET->Task, 0);


	return Ret;
}  


// --------------------------------------------------------------------------
// --- *hBuf points to an array of 2 handles. They must be H_NULL, when they
// --- should be initialized in this function. ------------------------------
// --- The handles must be released after the call to this function. --------
// --------------------------------------------------------------------------

int CreateNote (TEntryType *ET, HANDLE *hBuf, int GroupNr)
{
	int				Ret 			= ER_SUCCESS;
	int				Action			= 0;
	int				mustclosewin	= 0;
	short			CU				= 0;
	char			Title[40];
	WINDOW			Win;
	
	if (!WinOpen (&Win, MakeWinRect (5, 15, 235, 116), WF_NOBORDER)) Ret = ER_MALLOC;
	if (Ret == ER_SUCCESS)
	{
		mustclosewin = 1;
		EmptyScreenClient();
		FontSetSys (F_6x8);
		PrintHeadBox (LVGetHeadTitle (ET, GroupNr, Title));
		printf_xy (7, 19, NOTE_TITLE);
		DrawLine (7, 30, 230, 30, A_NORMAL);
		CU = CU_start ();
		Win.Flags &= ~WF_DIRTY;
		Ret = InitHandles (hBuf, 2);
	}
	
	if (Ret == ER_SUCCESS) Ret = CreateNoteEdit (ET, &Win, hBuf, 1, &Action );
	if (Ret == ER_SUCCESS) Ret = CreateNoteEdit (ET, &Win, hBuf, 0, &Action);

	if (mustclosewin)
	{
		CU_restore (CU);
		WinRemove (&Win, 0);
	}
			
	if (Ret == ER_SUCCESS) Ret = Action;

	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
