// C Header File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AGENDA V4.2  oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------


#ifndef __LANGUAGE__
#define __LANGUAGE__

#include "BuildOptions.h"

	extern char		PROGRAM_NAME[];
	extern char		DATA_FILE_NAME[];
	extern char		BACKUP_FILE_NAME[];

	extern char		CL_INFO[];
	extern char		CL_INFO_SHORT[];


	extern char		TASK_NAMES[4][15];
	extern char 	WEEK_DAYS[7][3];
	extern char		MONTHS[12][10];

	extern char		HEAD_STRING[];
	
	extern char		PUBLIC_HOLIDAYS[];
	
	extern char		TEXT_CHANGES[];
	extern char		TEXT_HASH_UPDATE[];
	extern char		TEXT_CONVERT_DATES[];
	extern char		TEXT_PH_KEYS[];

	extern char		MM_TITLE[];
	extern char		MM_INFO[];
	extern char		MM_CONFIG[];
	extern char		MM_PASSWORD[];
	extern char		MM_MAKE_BACKUP[];
	extern char		MM_RESTORE_BACKUP[];

	extern char		MA_TITLE[];
	extern char		MA_GOTO[];
	extern char		MA_DEL[];
	extern char		MA_VIEW[];
	extern char		MA_VIEW_MONTH[];
	extern char		MA_VIEW_WEEK[];
	extern char		MA_MOVE[];
	extern char		MA_SHORTCUT[];

	extern char		MD_DAY[];
	extern char		MD_OLD[];
	extern char		MD_AREA[];
	extern char		MD_WHOLE[];
	extern char		MD_TITLE[];
	extern char		MD_WHOLE_T[];
	extern char		MD_DAY_T[];
	extern char		MD_AREA_T[];
	extern char		MD_AREA_MSG[];
	extern char		MSG_DEL_OLD[];
	#if LANGUAGE == 1
		#define			MD_AREA_MSG_O1		32		// Delete area in Agenda
		#define			MD_AREA_MSG_O2		49
		#define			MD_AREA_MSG_O3		42		// MD_AREA_MSG_01 + 10
		#define			MSG_DEL_OLD_OFS		18
	#endif
	#if LANGUAGE == 2
		#define			MD_AREA_MSG_O1		26
		#define			MD_AREA_MSG_O2		43
		#define			MD_AREA_MSG_O3		36
		#define			MSG_DEL_OLD_OFS		24
	#endif
	#if LANGUAGE == 3								// italiano
		#define			MD_AREA_MSG_O1		41
		#define			MD_AREA_MSG_O2		56
		#define			MD_AREA_MSG_O3		51
		#define			MSG_DEL_OLD_OFS		24
	#endif

	extern char		MG_DAY[];
	extern char		MG_TODAY[];
	extern char		MG_ENTRY[];
	extern char		MG_WEEK[];
	extern char		MG_YEAR[];
	extern char		MG_TITLE[];
	extern char		MAM_TITLE[];
	extern char		MG_DAY_TEXT[];
	extern char		MM_DAY_TEXT[];
	extern char		MG_WEEK_TEXT[];
	extern char		MG_YEAR_TEXT[];

	extern char		MC_TITLE[];
	extern char		MC_USEPW[];
	extern char		MC_AUTOBACKUP[];
	extern char		MC_DATEFORMAT[];
	extern char		MC_PDSETUP[];
	extern char		MC_OP_YESNO[];
	extern char		MC_OP_AB[];
	extern char		MC_OP_DATEFORM[];
	extern char		MPH_TITLE[];

	extern char		MI_NAME[];
	extern char		MI_EMAIL[];
	extern char		MI_L1[];
	extern char		MI_L2[];
	extern char		MI_L3[];

	extern char		MSG_ER_TITLE[];
	extern char		MSG_ER_CREATE_DF[];
	extern char		MSG_ER_MEM[];
	extern char		MSG_ER_COMMON[];
	extern char		MSG_ER_PW_NOT_SEL[];
	extern char		MSG_ER_PW_NOT_SET[];
	extern char		MSG_ER_DIFFRENT_PW[];
	extern char		MSG_ER_PW_SHORT[];
	extern char		MSG_ER_DISABLE_PW[];
	extern char		MSG_ER_WRONG_PW[];
	extern char		MSG_ER_RST_BACKUP[];
	extern char		MSG_ER_DATAFILE[];
	extern char		MSG_ER_NOENTRY[];

	extern char		MSG_TITLE_HINT[];
	extern char		MSG_LOSEDATA[];
	extern char		MSG_MK_BKP_ASK[];
	extern char		MSG_MAKE_BACKUP[];
	extern char		MSG_RST_BKP_ASK[];
	extern char		MSG_RST_BACKUP[];

	extern char		DLG_ENTER_PW[];
	extern char		DLG_ENTER_PW3[];
	extern char		DLG_ENTER_PW1[];
	extern char		DLG_ENTER_PW2[];
	extern char		DLG_PW_TITLE[];

	extern char		MSG_AUTOBACKUP[];


	extern char		ADDRESS_FIELDS[];
	extern char		BIRTHDAY_TEXT[];
	extern char		BIRTHDAY_TITLE[];

	extern char		AB_TITLE[];
	extern char		NP_TITLE[];
	extern char		IL_TITLE[];
		
	extern char		LV_GROUP_TEXT[];
	extern char		MSG_GROUP_RENAME[];
		
	extern char		LV_GM_GROUP[];
	extern char		LV_GM_ADD[];
	extern char		LV_GM_RENAME[];
	extern char		LV_GM_DEL[];
	extern char		LV_GM_ADDADDRESS[];
	extern char		LV_GM_ADDNOTE[];
	extern char		LV_GM_ADDLINK[];
	extern char		LV_GM_SHORTCUT[];
		
	extern char		LV_DS_ADDRESS[];
	extern char		LV_DS_NOTE[];
	extern char		LV_DS_LINK[];
	extern char		LV_DS_ADD[];
	extern char		LV_DS_SHORTCUT[];
	extern char		LV_DS_DEL[];
	extern char		LV_DS_MOVE[];
	extern char		LV_DS_MOVE_FOLDER[];
	extern char		LV_DS_MOVE_UP[];
	extern char		LV_DS_MOVE_DOWN[];
	extern char		LV_DS_SORT[];

	extern char		SOURCE_GROUP[];
	extern char		DEST_GROUP[];
		
	extern char		MSG_FIELD_REQUIRED[];
	extern char		MSG_DEL_GROUP[];
	extern char		MSG_DEL_ADDRESS[];
	extern char		MSG_DEL_NOTE[];
	extern char		MSG_DEL_LINK[];
	extern char		MSG_GROUP_EXISTS[];
	extern char		MSG_NOTES_TITLE[];
	
	extern char		EMPTY[];
	extern char		GROUP_LIST[];
	extern char		NAME_LIST[];
	extern char		NOTE_LIST[];
	extern char		LINKS_LIST[];
	
	extern char		NOTE_TITLE[];

	extern char		TEXT_NONE[];
	extern char		TEXT_CW[];


// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo

#endif
