// C Source File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AGENDA V4.2  oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------


#include "IncludeAll.h"

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int IsEventKey (TListView *LV, TEntryType *ET)
{
	int		Ret = 0;
	int		key = LV->key;
	
	if (	(key == KEY_APPS) ||
			(key == KEY_DIAMOND + 'R') ||
			( (key == KEY_DIAMOND + 'K') && (LV->Focus != 0) ) ||
			( (key == ET->NewEntryKeyCombo) && !LV->noGroup ) ||
			( (key == KEY_DIAMOND + 'N') && (LV->Focus == 1) ) ||
			( (key == KEY_DIAMOND + 'M') && (LV->Focus == 2) ) ||
			( (key == KEY_BACKSPACE) && (LV->Focus == 1) ) ||
			( (key == KEY_BACKSPACE) && (LV->Focus == 2) ) ||
			( (key == '+') && (LV->Focus == 2) ) ||
			( (key == '-') && (LV->Focus == 2) ) ||
			( (key == KEY_ENTER) && (LV->Focus == 2) ) ||
			( (key == KEY_DIAMOND + 'S') && (LV->Focus == 2) )
	) Ret = 1;
			
	
	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int ListViewMenu (TEntryType *ET, int Focus, int GroupNr, int DatasetNr, int key, int *DidWhat)
{
	int			Ret		= ER_SUCCESS;
	int			idx		= 0;
	HANDLE		handle	= H_NULL;
	
	if (key == KEY_APPS)
	{
		switch (Focus)
		{
			case 0:
				handle = PopupNew (LV_GM_GROUP, 0);
				PopupAddText (handle, -1, LV_GM_ADD, RET_LV_GM_ADD);
				idx = PopupDo (handle, CENTER, CENTER, 0);
				break;
			
			case 1:
				handle = PopupNew (LV_GM_GROUP, 0);
				PopupAddText (handle, 0, LV_GM_GROUP, RET_LV_GM_GROUP);
				PopupAddText (handle, RET_LV_GM_GROUP, LV_GM_ADD, RET_LV_GM_ADD);
				PopupAddText (handle, RET_LV_GM_GROUP, LV_GM_RENAME, RET_LV_GM_RENAME);
				PopupAddText (handle, RET_LV_GM_GROUP, LV_GM_DEL, RET_LV_GM_DEL);
				PopupAddText (handle, -1, ET->NewEntryName, RET_LV_DS_ADD);
				PopupAddText (handle, -1, LV_GM_SHORTCUT, RET_LV_GM_SHORTCUT);
				idx = PopupDo (handle, 8, 60, 0);
				break;
				
			case 2:
				handle = PopupNew (ET->DatasetMenuName, 0);
				PopupAddText (handle, 0, LV_DS_MOVE, RET_LV_DS_MOVE);
				PopupAddText (handle, RET_LV_DS_MOVE, LV_DS_MOVE_FOLDER, RET_LV_DS_MOVE_FOLDER);
				PopupAddText (handle, RET_LV_DS_MOVE, LV_DS_MOVE_UP, RET_LV_DS_MOVE_UP);
				PopupAddText (handle, RET_LV_DS_MOVE, LV_DS_MOVE_DOWN, RET_LV_DS_MOVE_DOWN);
				PopupAddText (handle, -1, LV_DS_ADD, RET_LV_DS_ADD);
				PopupAddText (handle, -1, LV_DS_SORT, RET_LV_DS_SORT);
				PopupAddText (handle, -1, LV_DS_SHORTCUT, RET_LV_DS_SHORTCUT);
				PopupAddText (handle, -1, LV_DS_DEL, RET_LV_DS_DEL);
				idx = PopupDo (handle, 8, 60, 0);
				break;
		}

		HeapFree (handle);
		stIdle();
	}
	
	if ( key == KEY_ENTER) idx = RET_LV_DS_EDIT;
	if (key == KEY_DIAMOND + 'R') idx = RET_LV_GM_ADD;
	if (key == ET->NewEntryKeyCombo) idx = RET_LV_DS_ADD;
	if ( (key == KEY_BACKSPACE) && (Focus == 1) ) idx = RET_LV_GM_DEL;
	if ( (key == KEY_BACKSPACE) && (Focus == 2) ) idx = RET_LV_DS_DEL;
	if (key == '+') idx = RET_LV_DS_MOVE_DOWN;
	if (key == '-') idx = RET_LV_DS_MOVE_UP;
	if (key == KEY_DIAMOND + 'S') idx = RET_LV_DS_SORT;
	if (key == KEY_DIAMOND + 'M') idx = RET_LV_DS_MOVE_FOLDER;
	if (key == KEY_DIAMOND + 'N') idx = RET_LV_GM_RENAME;
	if ( (key == KEY_DIAMOND + 'K') && (Focus == 1) ) idx = RET_LV_GM_SHORTCUT;
	if ( (key == KEY_DIAMOND + 'K') && (Focus == 2) ) idx = RET_LV_DS_SHORTCUT;

	switch (idx)
	{
		case RET_LV_DS_ADD:
			Ret = MenuAddDataset (ET, GroupNr);
			break;

		case RET_LV_GM_ADD:
			Ret = MenuNewGroup (ET);
			break; 	

		case RET_LV_GM_DEL:
			Ret = MenuDelGroup (ET, GroupNr);
			break;
			
		case RET_LV_DS_DEL:
			Ret = MenuDelDataset (ET, GroupNr, DatasetNr);
			break;
			
		case RET_LV_DS_EDIT:
			Ret = MenuEditDataset (ET, GroupNr, DatasetNr);
			break;
			
		case RET_LV_GM_RENAME:
			Ret = MenuRenameGroup (ET, GroupNr);
			break;
			
		case RET_LV_DS_MOVE_FOLDER:
			Ret = MenuMoveDataset (ET, GroupNr, DatasetNr);
			break;
			
		case RET_LV_DS_MOVE_UP:
			Ret = MenuMoveDSUpDown (ET, GroupNr, DatasetNr, 0);
			break;

		case RET_LV_DS_MOVE_DOWN:
			Ret = MenuMoveDSUpDown (ET, GroupNr, DatasetNr, 1);
			break;
			
		case RET_LV_DS_SORT:
			Ret = MenuSortDatasets (ET, GroupNr);
			break;

		case RET_LV_GM_SHORTCUT:
			Ret = MenuLVShortcut (ET, GroupNr, DatasetNr, 0);
			break;
			
		case RET_LV_DS_SHORTCUT:
			Ret = MenuLVShortcut (ET, GroupNr, DatasetNr, 1);
			break;
	}	

	*DidWhat = idx;
	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuAddDataset (TEntryType *ET, int GroupNr)
{
	int			Ret 	= ER_SUCCESS;
	HANDLE		hBuf[9];
	
	memset (hBuf, 0, sizeof (hBuf));
	Ret = ET->CreateDataset (ET, hBuf, GroupNr);
	if (Ret == OK ) Ret = AddDataset (ET, hBuf, GroupNr, -1, 0, NULL, 0);

	ReleasehList (ET, hBuf);

	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuNewGroup (TEntryType *ET)
{
	int			Ret				= ER_SUCCESS;
	char		Buffer[520];
	int			BufSpace[]		= {513};
	int			Offset[]		= {0};

	Buffer[0] = '\0';
	do
	{
		Ret = RequestBox (ET->TaskTitle, LV_GROUP_TEXT, Buffer, BufSpace, 16, Offset, 1);
		if (Ret == OK)
		{
			if (strlenWithoutSpace (Buffer) == 0) Ret = CANCEL;
			else Ret = AddGroup (ET, Buffer);
		}
		if (Ret == ER_GROUP_EXISTS) MsgBox (MSG_ER_TITLE, MSG_GROUP_EXISTS, BT_OK, BT_NONE);
	}
	while (Ret == ER_GROUP_EXISTS);
	
	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuDelGroup (TEntryType *ET, int GroupNr)
{
	int			Ret			= ER_SUCCESS;
	
	if ( (Ret = MsgBox (ET->TaskTitle, MSG_DEL_GROUP, BT_OK, BT_CANCEL)) == OK)
	{
		Ret = DelGroup (ET, GroupNr);	
	}

	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuDelDataset (TEntryType *ET, int GroupNr, int DatasetNr)
{
	int			Ret			= ER_SUCCESS;
	
	if (MsgBox (ET->TaskTitle, ET->MsgDelDataset, BT_OK, BT_CANCEL) == OK)
	{
		Ret = DelDataset (ET, GroupNr, DatasetNr);
	}

	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuEditDataset (TEntryType *ET, int GroupNr, int DatasetNr)
{
	int				Ret			= ER_SUCCESS;
	unsigned int	shortcut	= 0;
	HANDLE			hBuf[9];
	TEntryHeader	*header;
	
	memset (hBuf, 0, sizeof(hBuf));
	Ret = GetDatasetInHandles (ET, GroupNr, DatasetNr, hBuf, &header);

	if (Ret == ER_SUCCESS)
	{
		shortcut = header->Shortcut;
		Ret = ET->CreateDataset (ET, hBuf, GroupNr);
	}

	if (Ret == OK) Ret = AddDataset (ET, hBuf, GroupNr, DatasetNr, 1, NULL, shortcut);

	ReleasehList (ET, hBuf);
		
	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuMoveDataset (TEntryType *ET, int GroupNr, int DatasetNr)
{
	int				Ret				= ER_SUCCESS;
	int				PDBuffer[]		= {1};
	HANDLE			hDialog			= H_NULL;
	HANDLE			hGroupNames 	= H_NULL;
	HANDLE			hPopupGroups	= H_NULL;
	char			LineBuf[50];
	char			SourceName[50];
	TEntryHeader	*Header;
	
	if (GetGroupCount(ET) <= 1) Ret = CANCEL;
	
	if (Ret == ER_SUCCESS) Ret = GetGroups (ET, &hGroupNames, GroupNr, 12);
	if (Ret == ER_SUCCESS)
	{
		Ret = MakePopup (NULL, HeapDeref (hGroupNames), 0, &hPopupGroups);
		HeapFreeHNULL (&hGroupNames);
	}
	if (Ret == ER_SUCCESS)
	{
		hDialog = DialogNewSimple (180,60);
		if (hDialog == H_NULL) Ret = ER_MALLOC;
	}
	if (Ret == ER_SUCCESS) Ret = GetGroup (ET, NULL, GroupNr, &Header);
	if (Ret == ER_SUCCESS)
	{
		strncpyex (SourceName, &Header->data, 12);
		sprintf (LineBuf, "%s: %s",SOURCE_GROUP,SourceName); 
		if ( DialogAddTitle (hDialog, ET->TaskTitle, BT_OK, BT_CANCEL) &&
			 DialogAddText (hDialog, 10, 15, LineBuf) &&
			 DialogAddPulldown (hDialog, 10, 27, DEST_GROUP, hPopupGroups, 0)
			 == H_NULL) Ret = ER_MALLOC;
	}

	if (Ret == ER_SUCCESS)
	{
		if (DialogDo (hDialog, CENTER, CENTER, NULL, PDBuffer) == KEY_ENTER )
		{
			if (PDBuffer[0] > GroupNr) PDBuffer[0]++;
			Ret = MoveDataset (ET, GroupNr, DatasetNr, PDBuffer[0]-1, -1);
		}
		else Ret = CANCEL;

	}

	HeapFreeHNULL (&hDialog);
	HeapFreeHNULL (&hPopupGroups);
		
	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuRenameGroup (TEntryType *ET, int GroupNr)
{
	int				Ret			= ER_SUCCESS;
	char			Buffer[520];
	int				BufSpace[]		= {513};
	int				Offset[]		= {0};
	TEntryHeader	*Header;

	Ret = GetGroup (ET, NULL, GroupNr, &Header);
	if (Ret == ER_SUCCESS)
	{
		do
		{
			strncpyex (Buffer, &Header->data, 512);
			Ret = RequestBox (ET->TaskTitle, MSG_GROUP_RENAME, Buffer, BufSpace, 16, Offset, 1);
	
			if (Ret == OK)
			{
				if (strlenWithoutSpace (Buffer) == 0) Ret = CANCEL;
				else Ret = RenameGroup (ET, GroupNr, Buffer);
			}
			if (Ret == ER_GROUP_EXISTS) MsgBox (MSG_ER_TITLE, MSG_GROUP_EXISTS, BT_OK, BT_NONE);

		}
		while (Ret == ER_GROUP_EXISTS);
	}
	
	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuMoveDSUpDown (TEntryType *ET, int GroupNr, int DatasetNr, int nUpDown)
{
	int		Ret				= ER_SUCCESS;
	int		DestDatasetNr	= DatasetNr;
	int		Count;
	
	Ret = GetDatasetCount (ET, GroupNr, &Count);
	if ( (Ret == ER_SUCCESS) && (Count > 1) )
	{
		if (nUpDown != 0) DestDatasetNr++;
		else
		{
			if (DestDatasetNr > 0) DestDatasetNr--;
			else Ret = CANCEL;
		}
		if (DestDatasetNr >= Count) Ret = CANCEL;

		if (Ret != CANCEL) Ret = MoveDataset (ET, GroupNr, DatasetNr, GroupNr, DestDatasetNr);
	}
	
	return Ret;	
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int	MenuSortDatasets (TEntryType *ET, int GroupNr)
{
	int		Ret				= ER_SUCCESS;
	int		changed			= 1;
	int		Count;
	int		i;
	char	*List1[ET->NumStrings];
	char	*List2[ET->NumStrings];
	
	Ret = GetDatasetCount (ET, GroupNr, &Count);
	
	stBusy();
	
	while (Ret == ER_SUCCESS && changed)
	{
		changed = 0;
		for (i = 0; i < Count-1; i++)
		{
			Ret = GetDataset (ET, GroupNr, i, List1, NULL);
			Ret |= GetDataset (ET, GroupNr, i+1, List2, NULL);
			if (Ret == ER_SUCCESS)
			{
				if ( (strcmp (List2[0], List1[0]) < 0) ||
				     ((strcmp (List2[0], List1[0]) == 0) && (strcmp (List2[1], List1[1]) < 0)) )
				{
					changed = 1;
					Ret = MoveDataset (ET, GroupNr, i, GroupNr, i+1); 
				}				  
			} 		
		}
		
	}	
	
	stIdle();

	return Ret;
}

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuLVShortcut (TEntryType *ET, int GroupNr, int DatasetNr, int caller)
{
	// --- caller == 0 if called from Group
	// --- caller == 1 if called from Dataset
	int				Ret		= ER_SUCCESS;
	TEntryHeader	*header;
	
	if (caller == 1) Ret = GetDatasetPtr (ET, GroupNr, DatasetNr, &header);
	if (caller == 0) Ret = GetGroup (ET, NULL, GroupNr, &header);
	
	if (Ret == ER_SUCCESS) Ret = MenuShortcut (header);
	
	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
