// C Source File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AGENDA V4.2  oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------


#include "IncludeAll.h"

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------


CALLBACK void CBShowClock (void)
{
	// FORCE_USE_CLOCK is used, to simulate the clock on VTI. This is used
	// to produce the screen shot movies for the documentation.
	
	#ifdef FORCE_USE_CLOCK
		static unsigned short	year, month, day, hour;
		static unsigned short   minute = 44, second = 12;
	#else
		static unsigned short	year, month, day, hour, minute, second;
	#endif	

	static int		counter = 0;
	char			buf[20];
	SCR_STATE		scrState;
	TDate			date;
	void			*oldA5;
	TAgenda			*oldA3;
	
	// --- restore a5 with jump table base (OPTIMIZE_ROM_CALLS)
	// --- and restore a3, the global Agenda struct pointer
	oldA3 = gr_Agenda;
	gr_Agenda = g_Agenda;

	#ifdef USE_OPT_ROM__CALLS
		oldA5 = __jmp_tbl;
		__jmp_tbl = *(void **)0xC8;
	#endif
	
	if (gr_Agenda->UseClock)
	{

	#ifdef FORCE_USE_CLOCK
		year = 2004;
		month = 10;
		day = 15;
		hour = 11;
		second++;
		if (second == 60)
		{
			second = 0;
			minute++;
		}
	#else
		DateAndTime_Get (&year, &month, &day, &hour, &minute, &second);
	#endif

		if (counter++ <= 10)
		{
			sprintf (buf, "%02d:%02d:%02d", hour, minute, second);
		}
		else
		{
			date.Month = month;
			date.Year = year;
			date.MonthDay = day;
			getDateString (0, &date, buf, FLAG_USE_YEAR, NULL);
			if (counter >= 15) counter = 0;
		}
		SaveScrState (&scrState);
		PortRestore();
		FontSetSys (F_6x8);
		DrawStrXY (186,4,buf, A_REVERSE);
		RestoreScrState (&scrState);
	}

	// --- restore original a5 and a3 with the values they had on entrance

	#ifdef USE_OPT_ROM__CALLS
		__jmp_tbl = (void *)oldA5;
	#endif
	gr_Agenda = oldA3;

}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
