// C Header File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AGENDA V4.2  oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------


#ifndef	__HUTILS__
#define	__HUTILS__

// --------------------------------------------------------------------------
// --- Structures -----------------------------------------------------------
// --------------------------------------------------------------------------


typedef union
{
	long int	Key;
	char		Byte[4];
} TEncodeKey;	

typedef struct
{
	TIdleLoop	idl;
	int			x0;
	int			y0;
	int			cols;
	int			rows;
	int			Flags;
	char		*data;
	int			NumLines;
	int			key;
	int			Redraw;
	SCR_RECT	srRect;
	SCR_RECT	srCursor;
	SCR_RECT	srScrollDown;
	SCR_RECT	srScrollUp;
	WIN_RECT	wrBorder;
	int			CursorIndex;
	int			ListIndex;
	int			Cursor;					// CU_NONE, CU_NORMAL, CU_LOSTFOCUS
	int			CIbefore;
	int			LIbefore;
	int			LineWidth;
	int			CharWidth;
	int			fgBorder;
	int			fgDontClear;
	int			fgCallback;
	int			fgDrawOnly;
	int			fgHintifEmpty;
	int			xPrintPos;
	int			yRefPos;
} TScrollList;

// --------------------------------------------------------------------------
// --- Prototypes -----------------------------------------------------------
// --------------------------------------------------------------------------

int				InitHandles (HANDLE hBuf[], int num);
char 			*strncpyex (char *dest, char *source, unsigned long n);
void 			truncTrail (char *string);
char 			getNumDelimiter (char *string);
void 			fillDisplay ();
void			WinCloseEx (WINDOW *win);
int 			SaveScreen (HANDLE *handle);
void 			RestoreScreen (HANDLE *handle);

int				ReallocHandle (HANDLE handle, unsigned int oldSize, unsigned long newSize, char *pos, char **newPos);
void 			HeapFreeHNULL (HANDLE *handle);
long int		RoundUpEven (long int Num);
void 			printfn (const char *data, int n);
char			*strfill (char *dest, char *source, unsigned long n, char ch);
unsigned int 	strlenWithoutSpace (char *data);
void 			ShowFatalError (int Error);
void 			ShowErrors (int Error);

void 			EncodeData (char *Data, long int Key, unsigned int Num);
int 			SplitString (char *String, char Split, HANDLE *handle);
char 			*GetSymnamePtr (char *Buffer, char *Folder, char *File);
int 			CopySym (SYM_STR Dest, SYM_STR Source, char **DestF);
int				GetSymAddr (SYM_STR Sym, char **Data);
int				GetSymSize (SYM_STR Sym, unsigned int *Size);
int				DelArchivedSym (SYM_STR Sym);

char			*GetStrFromList (char *data, unsigned int num);
char 			*GetStrFromListEx (char *data, unsigned int num);
unsigned int	GetNumStrs (char *data);

void 			ScrollList (TScrollList *SL, int *Index, int idlFlags);
int 			ScrollListSetCursor (TScrollList *SL, int idx);
void 			ScrollListCursorOff (TScrollList *SL);
void			ScrollListReassignData (TScrollList *SL, char *data);
void			ScrollListRedraw (TScrollList *SL, int useCursor);
void			ScrollListClearLines (TScrollList *SL, int a, int b);
TScrollList		InitScrollList (int Task, int x0, int y0, int cols, int rows, char *data, int cIdx, int lIdx, int Flags);

void 			DrawBorder (short x0, short y0, short x1, short y1);
void			DrawFilledRect (short x0, short y0, short x1, short y1);
int 			MsgBox (char *Title, char *Text, short LeftButton, short RightButton );
int 			RequestBox (char *Title, char *Request, char *Buffer, int BufSpace[], int RequestWidth, int Offset[], int num);
int				WinInputStr(WINDOW *win, int X, int Y, char *buffer, unsigned short maxlen);
int				PasswordDlg (char *Title, char *Text, char *Password);
int				MakePopup (char *Title, char *Data, int Height, HANDLE *handle);

int				countDigits (int value);
void 			poke_w_ex (void *ptr, int value);
int				getNumLetters (char *data, int width);

#define			SL_BORDER			1
#define			SL_CALLBACK			2
#define			SL_DONT_CLEAR		4
#define			SL_DRAW_ONLY		8
#define			SL_HINT_IF_EMPTY	16

#define			CU_NONE				0
#define			CU_NORMAL			1
#define			CU_LOSTFOCUS		2



// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo

#endif
