// C Header File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AgndConv V.E oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Date:         November 2003 ooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------


#ifndef __V3__
#define __V3__

#include "agndconv.h"

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

typedef struct
{
	unsigned int	Size;
	unsigned int	Version;
	unsigned int	Flags;
	unsigned int	LastDay;
	unsigned int	LastGroup;
	unsigned int	LastNameID;
	char			Password[10];
	unsigned int	nStarts;
	unsigned int	LastTask;
	unsigned int	AgendaPtr;
	unsigned int	AgendaSize;
	unsigned int	AddressbookPtr;
	unsigned int	AddressbookSize;
	unsigned int	NotesPtr;
	unsigned int	NotesSize;
	unsigned int	INetLinksPtr;
	unsigned int	INetLinksSize;
	unsigned int	AgendaData;				// DATA_PTR must point to this offset
	unsigned int	AddressbookData;
	unsigned int	NotesData;
	unsigned int	INetLinksData;
	char			pre0;
	char			Type[4];
	char			post0;
	char			Tag;
} TDataFileV3;


typedef struct
{
	char			*DataPtr;
	TDataFileV3		*Header;
	HANDLE			handle;
	char			PathBuf[19];
	char			*Path;
} TFile;


typedef struct
{
	unsigned int	Flag;
	unsigned int	Day;
	unsigned int	Reserved0;
	unsigned int	Reserved1;
	unsigned int	Reserved2;
	unsigned int	Size;
	char			Data;
} TAgendaHeaderV3;


typedef struct
{
	unsigned int	Flags;
	unsigned int	Size;
	char			data;
} TEntryHeaderV3;


// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

void 	InitEmptyDataFile (TDataFileV3 *DataFile);
int 	AdjustAgendaSize (TFile *File, long int SizeDelta);
int 	Update2to3 (HANDLE handle);

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

#endif
