// C Source File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AgndConv V.E oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Date:         November 2003 ooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------


#include "BuildOptions.h"
#include <tigcclib.h>

#include "Agndconv.h"
#include "consts.h"
#include "V3.h"
#include "V4.h"

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

long getNewSize (WINDOW *Win, char *file)
{
	int				agendaEntries	= 0;
	int				contactEntries	= 0;
	int				notepadEntries	= 0;
	int				linksEntries	= 0;
	long			newSize			= 91;		// size of empty agnddata v4
	char			Buf[50];
	TAgendaHeaderV3	*A3Header;
	TEntryHeaderV3	*E3Header;
	TDataFileV3		*dfV3			= (TDataFileV3 *)file;

	A3Header = (TAgendaHeaderV3 *)(file + dfV3->AgendaPtr);
	while (A3Header->Flag != 0)
	{
		newSize += A3Header->Size - 4;
		agendaEntries++;
		sprintf (Buf, "Agenda entries found .. %5d", agendaEntries);
		WinStrXY (Win, 10, 15, Buf); 
		sprintf (Buf, "New size .............. %5ld", newSize);
		WinStrXY (Win, 10, 65, Buf); 
		A3Header = (TAgendaHeaderV3 *)( (char *)A3Header + A3Header->Size);
	}

	E3Header = (TEntryHeaderV3 *)(file + dfV3->AddressbookPtr);
	while (E3Header->Flags != 0)
	{
		newSize += E3Header->Size + 2;
		contactEntries++;
		sprintf (Buf, "Address book entries .. %5d", contactEntries);
		WinStrXY (Win, 10, 25, Buf); 
		sprintf (Buf, "New size .............. %5ld", newSize);
		WinStrXY (Win, 10, 65, Buf); 
		E3Header = (TEntryHeaderV3 *)( (char *)E3Header + E3Header->Size);
	}

	E3Header = (TEntryHeaderV3 *)(file + dfV3->NotesPtr);
	while (E3Header->Flags != 0)
	{
		newSize += E3Header->Size + 2;
		notepadEntries++;
		sprintf (Buf, "Notepad entries ....... %5d", notepadEntries);
		WinStrXY (Win, 10, 35, Buf); 
		sprintf (Buf, "New size .............. %5ld", newSize);
		WinStrXY (Win, 10, 65, Buf); 
		E3Header = (TEntryHeaderV3 *)( (char *)E3Header + E3Header->Size);
	}

	E3Header = (TEntryHeaderV3 *)(file + dfV3->INetLinksPtr);
	while (E3Header->Flags != 0)
	{
		newSize += E3Header->Size + 2;
		linksEntries++;
		sprintf (Buf, "Web links entries ..... %5d", linksEntries);
		WinStrXY (Win, 10, 45, Buf); 
		sprintf (Buf, "New size .............. %5ld", newSize);
		WinStrXY (Win, 10, 65, Buf); 
		E3Header = (TEntryHeaderV3 *)( (char *)E3Header + E3Header->Size);
	}

	return newSize;
}

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

void convertToV4 (char *file, char *source)
{
	TDataFileV4			*dfV4	= (TDataFileV4 *)file;
	TDataFileV3			*dfV3	= (TDataFileV3 *)source;
	TAgendaHeaderV3		*AHV3;
	TAgendaHeaderV4		*AHV4;
	TEntryHeaderV3		*EHV3;
	TEntryHeaderV4		*EHV4;
	int					size;
	
	// --- converting Agendadata
	dfV4->AgendaPtr = 74;
	AHV3 = (TAgendaHeaderV3 *)(source + 42);
	AHV4 = (TAgendaHeaderV4 *)(file + 74);
	size = 2;
	while (AHV3->Flag != 0)
	{
		AHV4->Flags = AHV3->Flag;
		AHV4->Day = AHV3->Day;
		AHV4->Size = AHV3->Size - 4;
		memcpy (&AHV4->Data, &AHV3->Data, AHV3->Size - 12);
		size += AHV4->Size;
		AHV3 = (TAgendaHeaderV3 *)( (char *)AHV3 + AHV3->Size); 
		AHV4 = (TAgendaHeaderV4 *)( (char *)AHV4 + AHV4->Size);
	}
	dfV4->AgendaSize = size;
	
	// --- making Autofields section
	
	dfV4->AutofieldPtr = (char *)AHV4 + 2 - file;
	dfV4->AutofieldSize = 2;
	
	// --- converting contacts
	dfV4->AddressbookPtr = (char *)AHV4 + 2 - file + 2;		// two Agenda 0-terms and two Autofield 0-terms
	EHV4 = (TEntryHeaderV4 *)( (char *)AHV4 + 2 + 2);
	EHV3 = (TEntryHeaderV3 *)(source + dfV3->AddressbookPtr);
	size = 2;
	while (EHV3->Flags != 0)
	{
		EHV4->Flags = EHV3->Flags;
		EHV4->Size = EHV3->Size + 2;
		memcpy (&EHV4->Data, &EHV3->data, EHV3->Size - 4);
		size += EHV4->Size;
		EHV3 = (TEntryHeaderV3 *)( (char *)EHV3 + EHV3->Size);
		EHV4 = (TEntryHeaderV4 *)( (char *)EHV4 + EHV4->Size);
	}
	dfV4->AddressbookSize = size;
	
	// --- converting notepad
	dfV4->NotesPtr = (char *)EHV4 + 2 - file;		// two abook 0-terms
	EHV4 = (TEntryHeaderV4 *)( (char *)EHV4 + 2);
	EHV3 = (TEntryHeaderV3 *)(source + dfV3->NotesPtr);
	size = 2;
	while (EHV3->Flags != 0)
	{
		EHV4->Flags = EHV3->Flags;
		EHV4->Size = EHV3->Size + 2;
		memcpy (&EHV4->Data, &EHV3->data, EHV3->Size - 4);
		size += EHV4->Size;
		EHV3 = (TEntryHeaderV3 *)( (char *)EHV3 + EHV3->Size);
		EHV4 = (TEntryHeaderV4 *)( (char *)EHV4 + EHV4->Size);
	}
	dfV4->NotesSize = size;
		
	// --- converting weblinks
	dfV4->INetLinksPtr = (char *)EHV4 + 2 - file;		// two notepad 0-terms
	EHV4 = (TEntryHeaderV4 *)( (char *)EHV4 + 2);
	EHV3 = (TEntryHeaderV3 *)(source + dfV3->INetLinksPtr);
	size = 2;
	while (EHV3->Flags != 0)
	{
		EHV4->Flags = EHV3->Flags;
		EHV4->Size = EHV3->Size + 2;
		memcpy (&EHV4->Data, &EHV3->data, EHV3->Size - 4);
		size += EHV4->Size;
		EHV3 = (TEntryHeaderV3 *)( (char *)EHV3 + EHV3->Size);
		EHV4 = (TEntryHeaderV4 *)( (char *)EHV4 + EHV4->Size);
	}
	dfV4->INetLinksSize = size;
}

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int Update3to4 (HANDLE handle)
{
	int				Ret				= ER_SUCCESS;
  	WINDOW 			*Win 			= NULL;
	int				OldSize			= 0;
	long			newSize;
	char			OldSizeBuf[50];
	int				closeWin		= 0;
	char			*file			= HeapDeref (handle);
	char			*source			= NULL;
	HANDLE			hSource			= H_NULL;
	TDataFileV3		*dfV3			= (TDataFileV3 *)file;
	TDataFileV4		*dfV4			= NULL;

	HeapLock (handle);
	if ( MsgBox ((char *)"Conversion", (char *)"Update agnddata version 3 to 4?\0Note: Once converted, you can't\0downgrade again!\0 \0Warning: Make a backup to PC first!\0Continue?\0", BT_YES, BT_NO) == OK )
	{
		Win = HeapAllocPtr (sizeof (WINDOW));
		if (Win == NULL) Ret = ER_MALLOC;
		if (Ret == ER_SUCCESS)
		{
			if (WinOpen (Win, MakeWinRect (20, 6, 220, 117), WF_SAVE_SCR | WF_TTY | WF_TITLE | WF_ROUNDEDBORDER, "Conversion") == 0) Ret = ER_MALLOC;
		}
		if (Ret == ER_SUCCESS)
		{			
			closeWin = 1;
			WinActivate (Win);
			WinFont (Win, F_6x8);
			WinAttr (Win, A_REPLACE);
			OldSize = peek_w (HeapDeref (handle))+2;
			sprintf (OldSizeBuf, "Old size .............. %5d", OldSize);
			WinStrXY (Win, 10, 5, OldSizeBuf); 
			WinStrXY (Win, 10, 15, "Agenda entries found ..     x"); 
			WinStrXY (Win, 10, 25, "Address book entries ..     x"); 
			WinStrXY (Win, 10, 35, "Notepad entries .......     x"); 
			WinStrXY (Win, 10, 45, "Web links entries .....     x"); 
			WinStrXY (Win, 10, 65, "New size ..............     x"); 


			// --- decode file, if necessery
			if (dfV3->Flags & FLAG_ENCODED)
			{
				dfV3->Flags = dfV3->Flags & ~FLAG_ENCODED;
				EncodeData (file + 42, ENCODE_KEY_D, OldSize -N_TERM_BYTES - 42 );
			}

			newSize = getNewSize(Win, file);

			// --- make a temporary copy of the old file
			HeapUnlock (handle);

			if ( (hSource = HeapAlloc (OldSize)) == H_NULL) Ret = ER_MALLOC;
			else
			{
				HeapLock (hSource);
				source = HeapDeref (hSource);
				memcpy (source, HeapDeref (handle), OldSize);
				dfV3 = (TDataFileV3 *)source;	
			}

			// --- realloc the file to fit new size
			if (Ret == ER_SUCCESS)
				{
				if (HeapRealloc (handle, newSize) == H_NULL) Ret = ER_MALLOC;
				HeapLock (handle);
				file = HeapDeref (handle);
				dfV4 = (TDataFileV4 *)file;
			}
			
			// copy the file Header
			if (Ret == ER_SUCCESS)
			{
				WinStrXY (Win, 10, 75, "--- converting ---");
				dfV4->Size = newSize -2;
				dfV4->Version = 0xFF04;				// Version 4
				dfV4->Flags = 8;					// AutoBackup 5 Starts
				dfV4->LastAgendaDay = dfV3->LastDay;
				memset (file + 6, 0, newSize - 6);	// empty the file
				// --- copy the file type info
				memmove (file + newSize - N_TERM_BYTES, source + OldSize - N_TERM_BYTES, N_TERM_BYTES);
				convertToV4 (file, source);
			}
				
			// --- reencode file (, if decoded)
			if (!(dfV4->Flags & FLAG_ENCODED))
			{
				dfV4->Flags = dfV4->Flags | FLAG_ENCODED;
				EncodeData (file + 74, ENCODE_KEY_D, newSize -N_TERM_BYTES - 74 );
			}
		}
		
		DrawStaticButton (Win, BT_OK, 10);
		if (Ret == ER_SUCCESS) WinStrXY (Win, 10, 75, "Successfully converted!");
		else WinStrXY (Win, 10, 75, "Conversion failed!");
		ngetchx();	

		if (closeWin) WinClose (Win);
		
		if (Ret == ER_SUCCESS) MsgBox ((char *)"Conversion", (char *)"Note, that the options have been\0reseted to their default values.\0", BT_OK, BT_NONE);
	}
	else Ret = CANCEL;

	ST_busy (ACTIVITY_IDLE);
	HeapUnlock (handle);
	if (hSource)
	{
		HeapUnlock (hSource);
		HeapFree (hSource);
	}
	if (Win) HeapFreePtr (Win);
			
	return Ret;
}

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

