// C Header File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AgndConv V.E oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Date:         November 2003 ooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------


#ifndef __V4__
#define __V4__

#include "agndconv.h"

int Update3to4 (HANDLE handle);

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

typedef struct
{
	unsigned int	Size;
	unsigned int	Version;			// Higher byte always 0xFF,to identify first version, which didn't have a versioninfo
	unsigned int	Flags;
	unsigned long	SpecialDays;
	char			Password[10];
	unsigned int	nStarts;			// num starts since last backup
	unsigned int	LastTask;			// last used task: Agenda || Addressbook || Notepad || Weblinks

	unsigned int	LastAgendaDay;		// last viewed day
	unsigned int	LastAgendaEditPos;	// cursor position of dayplan editor
	unsigned int	LastAgendaMode;		// view mode: Month view, normal view

	unsigned int	LastABGroup;		// group on which the cursor was
	unsigned int	LastABEntry;		// entry on which the cursor was
	unsigned int	LastABEditPos;		// last edited addressbook string
	unsigned int	LastABMode;			// not yet implemented

	unsigned int	LastNPGroup;
	unsigned int	LastNPEntry;
	unsigned int	LastNPEditPos;
	unsigned int	LastNPMode;

	unsigned int	LastWLGroup;
	unsigned int	LastWLEntry;
	unsigned int	LastWLEditPos;
	unsigned int	LastWLMode;

	unsigned int	AgendaPtr;
	unsigned int	AgendaSize;

	unsigned int	AutofieldPtr;
	unsigned int	AutofieldSize;

	unsigned int	AddressbookPtr;
	unsigned int	AddressbookSize;

	unsigned int	NotesPtr;
	unsigned int	NotesSize;				

	unsigned int	INetLinksPtr;
	unsigned int	INetLinksSize;

	unsigned int	AgendaData;			// DATA_PTR must point to this offset
	unsigned int	AutofieldData;
	unsigned int	AddressbookData;
	unsigned int	NotesData;
	unsigned int	INetLinksData;

	char			pre0;				// File end
	char			Type[4];			// initialised with 'data'
	char			post0;
	char			Tag;				// OTH_TAG
} TDataFileV4;


typedef struct
{
	unsigned int	Flags;
	unsigned int	Day;
	unsigned int	Shortcut;
	unsigned int	Size;
	char			Data;
} TAgendaHeaderV4;


typedef struct
{
	unsigned int	Flags;
	unsigned int	Shortcut;
	unsigned int	Size;
	char			Data;
} TEntryHeaderV4;


// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

#endif
